------------------------------------------------------------------------------
--                                                                          --
--                           POLYORB COMPONENTS                             --
--                                                                          --
--                    C O N V _ F R A M E . H E L P E R                     --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--            Copyright (C) 2006 Free Software Foundation, Inc.             --
--                                                                          --
-- This specification is derived from the CORBA Specification, and adapted  --
-- for use with PolyORB. The copyright notice above, and the license        --
-- provisions that follow apply solely to the contents neither explicitely  --
-- nor implicitely specified by the CORBA Specification defined by the OMG. --
--                                                                          --
-- PolyORB is free software; you  can  redistribute  it and/or modify it    --
-- under terms of the  GNU General Public License as published by the  Free --
-- Software Foundation;  either version 2,  or (at your option)  any  later --
-- version. PolyORB is distributed  in the hope that it will be  useful,    --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License distributed with PolyORB; see file COPYING. If    --
-- not, write to the Free Software Foundation, 51 Franklin Street, Fifth    --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
--
--
--
--
--
--
--
--                  PolyORB is maintained by AdaCore                        --
--                     (email: sales@adacore.com)                           --
--                                                                          --
------------------------------------------------------------------------------

with PolyORB.Any;

package CONV_FRAME.Helper is

   --  CodeSetId type

   TC_CodeSetId : CORBA.TypeCode.Object
     := CORBA.TypeCode.Internals.To_CORBA_Object
     (PolyORB.Any.TypeCode.TC_Alias);

   function From_Any (Item : CORBA.Any) return CodeSetId;

   function To_Any (Item : CodeSetId) return CORBA.Any;

   --  CodeSetComponent structure

   TC_IDL_SEQUENCE_CONV_FRAME_CodeSetId : CORBA.TypeCode.Object;

   function From_Any
     (Item : CORBA.Any) return IDL_SEQUENCE_CONV_FRAME_CodeSetId.Sequence;

   function To_Any
     (Item : IDL_SEQUENCE_CONV_FRAME_CodeSetId.Sequence) return CORBA.Any;

   TC_CodeSetComponent : CORBA.TypeCode.Object
     := CORBA.TypeCode.Internals.To_CORBA_Object
     (PolyORB.Any.TypeCode.TC_Struct);

   function From_Any (Item : CORBA.Any) return CodeSetComponent;

   function To_Any (Item : CodeSetComponent) return CORBA.Any;

   --  CodeSetComponentInfo structure

   TC_CodeSetComponentInfo : CORBA.TypeCode.Object
     := CORBA.TypeCode.Internals.To_CORBA_Object
     (PolyORB.Any.TypeCode.TC_Struct);

   function From_Any (Item : CORBA.Any) return CodeSetComponentInfo;

   function To_Any (Item : CodeSetComponentInfo) return CORBA.Any;

   --  CodeSetContext structure

   TC_CodeSetContext : CORBA.TypeCode.Object
     := CORBA.TypeCode.Internals.To_CORBA_Object
     (PolyORB.Any.TypeCode.TC_Struct);

   function From_Any (Item : CORBA.Any) return CodeSetContext;

   function To_Any (Item : CodeSetContext) return CORBA.Any;

end CONV_FRAME.Helper;
