------------------------------------------------------------------------------
--                                                                          --
--                           POLYORB COMPONENTS                             --
--                                                                          --
--               D Y N A M I C A N Y . D Y N S E Q U E N C E                --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--         Copyright (C) 2005-2006, Free Software Foundation, Inc.          --
--                                                                          --
-- PolyORB is free software; you  can  redistribute  it and/or modify it    --
-- under terms of the  GNU General Public License as published by the  Free --
-- Software Foundation;  either version 2,  or (at your option)  any  later --
-- version. PolyORB is distributed  in the hope that it will be  useful,    --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License distributed with PolyORB; see file COPYING. If    --
-- not, write to the Free Software Foundation, 51 Franklin Street, Fifth    --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
--
--
--
--
--
--
--
--                  PolyORB is maintained by AdaCore                        --
--                     (email: sales@adacore.com)                           --
--                                                                          --
------------------------------------------------------------------------------

with CORBA;

with DynamicAny.DynAny;

package DynamicAny.DynSequence is

   type Local_Ref is new DynamicAny.DynAny.Local_Ref with null record;

   function Get_Length (Self : Local_Ref) return CORBA.Unsigned_Long;

   procedure Set_Length
     (Self : Local_Ref;
      Len  : CORBA.Unsigned_Long);

   function Get_Elements (Self : Local_Ref) return AnySeq;

   procedure Set_Elements
     (Self  : Local_Ref;
      Value : AnySeq);

   function Get_Elements_As_Dyn_Any (Self : Local_Ref) return DynAnySeq;

   procedure Set_Elements_As_Dyn_Any
     (Self  : Local_Ref;
      Value : DynAnySeq);

   --  Repository Ids

   Repository_Id                         : constant Standard.String
     := "IDL:omg.org/DynamicAny/DynSequence:1.0";

   Get_Elements_Repository_Id            : constant Standard.String
     := "IDL:omg.org/DynamicAny/DynSequence/get_elements:1.0";

   Get_Elements_As_Dyn_Any_Repository_Id : constant Standard.String
     := "IDL:omg.org/DynamicAny/DynSequence/get_elements_as_dyn_any:1.0";

   Get_Length_Repository_Id              : constant Standard.String
     := "IDL:omg.org/DynamicAny/DynSequence/get_length:1.0";

   Set_Elements_Repository_Id            : constant Standard.String
     := "IDL:omg.org/DynamicAny/DynSequence/set_elements:1.0";

   Set_Elements_As_Dyn_Any_Repository_Id : constant Standard.String
     := "IDL:omg.org/DynamicAny/DynSequence/set_elements_as_dyn_any:1.0";

   Set_Length_Repository_Id              : constant Standard.String
     := "IDL:omg.org/DynamicAny/DynSequence/set_length:1.0";

end DynamicAny.DynSequence;
