------------------------------------------------------------------------------
--                                                                          --
--                           POLYORB COMPONENTS                             --
--                                                                          --
--                 PORTABLEINTERCEPTOR.IORINTERCEPTOR_3_0                   --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--         Copyright (C) 2004-2006, Free Software Foundation, Inc.          --
--                                                                          --
-- This specification is derived from the CORBA Specification, and adapted  --
-- for use with PolyORB. The copyright notice above, and the license        --
-- provisions that follow apply solely to the contents neither explicitely  --
-- nor implicitely specified by the CORBA Specification defined by the OMG. --
--                                                                          --
-- PolyORB is free software; you  can  redistribute  it and/or modify it    --
-- under terms of the  GNU General Public License as published by the  Free --
-- Software Foundation;  either version 2,  or (at your option)  any  later --
-- version. PolyORB is distributed  in the hope that it will be  useful,    --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License distributed with PolyORB; see file COPYING. If    --
-- not, write to the Free Software Foundation, 51 Franklin Street, Fifth    --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
--
--
--
--
--
--
--
--                  PolyORB is maintained by AdaCore                        --
--                     (email: sales@adacore.com)                           --
--                                                                          --
------------------------------------------------------------------------------

with PortableInterceptor.IORInfo;
with PortableInterceptor.IORInterceptor;

package PortableInterceptor.IORInterceptor_3_0 is

   type Local_Ref is
      new PortableInterceptor.IORInterceptor.Local_Ref with null record;

   procedure Components_Established
     (Self : Local_Ref;
      Info : PortableInterceptor.IORInfo.Local_Ref);

   procedure Adapter_Manager_State_Changed
     (Self  : Local_Ref;
      Id    : AdapterManagerId;
      State : AdapterState);

--   procedure Adapter_State_Changed
--     (Self      : Local_Ref;
--      Templates : ObjectReferenceTemplateSeq;
--      State     : AdapterState);

   --  Repository Ids

   IORInterceptor_3_0_Repository_Root          : constant Standard.String
     := "IDL:PortableInterceptor/IORInterceptor_3_0";

   Repository_Id                               : constant Standard.String
     := IORInterceptor_3_0_Repository_Root & ":1.0";

   Adapter_Manager_State_Changed_Repository_Id : constant Standard.String
     := IORInterceptor_3_0_Repository_Root
          & "/adapter_manager_state_changed:1.0";

   Adapter_State_Changed_Repository_Id         : constant Standard.String
     := IORInterceptor_3_0_Repository_Root & "/adapter_state_changed:1.0";

   Components_Established_Repository_Id        : constant Standard.String
     := IORInterceptor_3_0_Repository_Root & "/components_established:1.0";

end PortableInterceptor.IORInterceptor_3_0;
