------------------------------------------------------------------------------
--                                                                          --
--                           POLYORB COMPONENTS                             --
--                                                                          --
--              PORTABLEINTERCEPTOR.SERVERREQUESTINTERCEPTOR                --
--                                                                          --
--                                 B o d y                                  --
--                                                                          --
--         Copyright (C) 2004-2006, Free Software Foundation, Inc.          --
--                                                                          --
-- PolyORB is free software; you  can  redistribute  it and/or modify it    --
-- under terms of the  GNU General Public License as published by the  Free --
-- Software Foundation;  either version 2,  or (at your option)  any  later --
-- version. PolyORB is distributed  in the hope that it will be  useful,    --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License distributed with PolyORB; see file COPYING. If    --
-- not, write to the Free Software Foundation, 51 Franklin Street, Fifth    --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
--
--
--
--
--
--
--
--                  PolyORB is maintained by AdaCore                        --
--                     (email: sales@adacore.com)                           --
--                                                                          --
------------------------------------------------------------------------------

with CORBA.Object;

with PortableInterceptor.ServerRequestInterceptor.Impl;

package body PortableInterceptor.ServerRequestInterceptor is

   ---------------------
   -- Receive_Request --
   ---------------------

   procedure Receive_Request
     (Self : Local_Ref;
      RI   : PortableInterceptor.ServerRequestInfo.Local_Ref)
   is
      Self_Ref : CORBA.Object.Ref
        := CORBA.Object.Ref (Self);
   begin

      if CORBA.Object.Is_Nil (Self_Ref) then
         CORBA.Raise_Inv_Objref (CORBA.Default_Sys_Member);
      end if;

      PortableInterceptor.ServerRequestInterceptor.Impl.Receive_Request
        (PortableInterceptor.ServerRequestInterceptor.Impl.Object_Ptr
           (Entity_Of (Self)),
         RI);
   end Receive_Request;

   --------------------------------------
   -- Receive_Request_Service_Contexts --
   --------------------------------------

   procedure Receive_Request_Service_Contexts
     (Self : Local_Ref;
      RI   : PortableInterceptor.ServerRequestInfo.Local_Ref)
   is
      Self_Ref : constant CORBA.Object.Ref := CORBA.Object.Ref (Self);
   begin

      if CORBA.Object.Is_Nil (Self_Ref) then
         CORBA.Raise_Inv_Objref (CORBA.Default_Sys_Member);
      end if;

      Impl.Receive_Request_Service_Contexts
        (PortableInterceptor.ServerRequestInterceptor.Impl.Object_Ptr
          (Entity_Of (Self)),
         RI);
   end Receive_Request_Service_Contexts;

   --------------------
   -- Send_Exception --
   --------------------

   procedure Send_Exception
     (Self : Local_Ref;
      RI   : PortableInterceptor.ServerRequestInfo.Local_Ref)
   is
      Self_Ref : constant CORBA.Object.Ref := CORBA.Object.Ref (Self);
   begin

      if CORBA.Object.Is_Nil (Self_Ref) then
         CORBA.Raise_Inv_Objref (CORBA.Default_Sys_Member);
      end if;

      PortableInterceptor.ServerRequestInterceptor.Impl.Send_Exception
        (PortableInterceptor.ServerRequestInterceptor.Impl.Object_Ptr
           (Entity_Of (Self)),
         RI);
   end Send_Exception;

   ----------------
   -- Send_Other --
   ----------------

   procedure Send_Other
     (Self : Local_Ref;
      RI   : PortableInterceptor.ServerRequestInfo.Local_Ref)
   is
      Self_Ref : constant CORBA.Object.Ref := CORBA.Object.Ref (Self);
   begin

      if CORBA.Object.Is_Nil (Self_Ref) then
         CORBA.Raise_Inv_Objref (CORBA.Default_Sys_Member);
      end if;

      PortableInterceptor.ServerRequestInterceptor.Impl.Send_Other
        (PortableInterceptor.ServerRequestInterceptor.Impl.Object_Ptr
           (Entity_Of (Self)),
         RI);
   end Send_Other;

   ----------------
   -- Send_Reply --
   ----------------

   procedure Send_Reply
     (Self : Local_Ref;
      RI   : PortableInterceptor.ServerRequestInfo.Local_Ref)
   is
      Self_Ref : constant CORBA.Object.Ref := CORBA.Object.Ref (Self);
   begin

      if CORBA.Object.Is_Nil (Self_Ref) then
         CORBA.Raise_Inv_Objref (CORBA.Default_Sys_Member);
      end if;

      PortableInterceptor.ServerRequestInterceptor.Impl.Send_Reply
        (PortableInterceptor.ServerRequestInterceptor.Impl.Object_Ptr
           (Entity_Of (Self)),
         RI);
   end Send_Reply;

end PortableInterceptor.ServerRequestInterceptor;
