------------------------------------------------------------------------------
--                                                                          --
--                           POLYORB COMPONENTS                             --
--                                                                          --
--              PORTABLEINTERCEPTOR.SERVERREQUESTINTERCEPTOR                --
--                                                                          --
--                                 S p e c                                  --
--                                                                          --
--         Copyright (C) 2004-2006, Free Software Foundation, Inc.          --
--                                                                          --
-- This specification is derived from the CORBA Specification, and adapted  --
-- for use with PolyORB. The copyright notice above, and the license        --
-- provisions that follow apply solely to the contents neither explicitely  --
-- nor implicitely specified by the CORBA Specification defined by the OMG. --
--                                                                          --
-- PolyORB is free software; you  can  redistribute  it and/or modify it    --
-- under terms of the  GNU General Public License as published by the  Free --
-- Software Foundation;  either version 2,  or (at your option)  any  later --
-- version. PolyORB is distributed  in the hope that it will be  useful,    --
-- but WITHOUT ANY WARRANTY;  without even the implied warranty of MERCHAN- --
-- TABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public --
-- License  for more details.  You should have received  a copy of the GNU  --
-- General Public License distributed with PolyORB; see file COPYING. If    --
-- not, write to the Free Software Foundation, 51 Franklin Street, Fifth    --
-- Floor, Boston, MA 02111-1301, USA.                                       --
--                                                                          --
--
--
--
--
--
--
--
--                  PolyORB is maintained by AdaCore                        --
--                     (email: sales@adacore.com)                           --
--                                                                          --
------------------------------------------------------------------------------

with PortableInterceptor.ServerRequestInfo;
with PortableInterceptor.Interceptor;

package PortableInterceptor.ServerRequestInterceptor is

   type Local_Ref is
     new PortableInterceptor.Interceptor.Local_Ref with null record;

   procedure Receive_Request_Service_Contexts
     (Self : Local_Ref;
      RI   : PortableInterceptor.ServerRequestInfo.Local_Ref);

   procedure Receive_Request
     (Self : Local_Ref;
      RI   : PortableInterceptor.ServerRequestInfo.Local_Ref);

   procedure Send_Reply
     (Self : Local_Ref;
      RI   : PortableInterceptor.ServerRequestInfo.Local_Ref);

   procedure Send_Exception
     (Self : Local_Ref;
      RI   : PortableInterceptor.ServerRequestInfo.Local_Ref);

   procedure Send_Other
     (Self : Local_Ref;
      RI   : PortableInterceptor.ServerRequestInfo.Local_Ref);

   --  Repository_Ids

   ServerRequestInterceptor_Root_Repository_Id : constant Standard.String
     := "IDL:omg.org/PortableInterceptor/ServerRequestInterceptor";

   Repository_Id : constant Standard.String
     := ServerRequestInterceptor_Root_Repository_Id & ":1.0";

   Receive_Request_Service_Contexts_Repository_Id : constant Standard.String
     := ServerRequestInterceptor_Root_Repository_Id
          & "/receive_request_service_contexts:1.0";

   Receive_Request_Repository_Id : constant Standard.String
     := ServerRequestInterceptor_Root_Repository_Id & "/receive_request:1.0";

   Send_Reply_Repository_Id : constant Standard.String
     := ServerRequestInterceptor_Root_Repository_Id & "/send_reply:1.0";

   Send_Exception_Repository_Id : constant Standard.String
     := ServerRequestInterceptor_Root_Repository_Id & "/send_exception:1.0";

   Send_Other_Repository_Id : constant Standard.String
     := ServerRequestInterceptor_Root_Repository_Id & "/send_other:1.0";

end PortableInterceptor.ServerRequestInterceptor;
